//   DIGNUM.C   To change station number in DIGION files.
//        New Site Number = 0, to just list old numbers with no changes.
//        Program adapted from  DIGION.C  and  GETFILE.C.  JET, 22-07-96.
// 6'97.  Read 3rd arg = offset, to correct all ionogs.
//        fsite to byte (was int),  so can store byte:
//        offset = (Freq corn= 0,1 or 2) *64,  + (32 + ht corn).]
//----------------------------------------------------------------------------
typedef unsigned char  byte;
struct  fhead     {    //    HEADER  for each daily file:
	int    fnum;       // Total Number of ionograms in file.
	long   fsize;      // Total file size in bytes.
    byte   fsite;      // Station: 0,1=Ackld, 2=Chch,....
    byte   fofset;     // Pixel offset to use for this data file.
	int    fyear;      // Year of file (year is not recorded with
	byte   fmonth;     //                  individual ionograms).
	byte   fday;
	byte   fhour;      // Date = last file modification date.
	byte   fminute;
	byte   fsecond;
	byte   fflags; };  // Various flags - see  FILE.H, IONO.H.
#define HSIZE   16     // Size of header struct above, in bytes.
#include  <stdio.h>
#include  <conio.h>
#include  <stdlib.h>
#include  <string.h>
struct fhead fp;
FILE *ptr;
char c, *dname;
char aday[2], datfile[30], getfile[33];
int  nodat=0, dsite, dyear, insite, newsite=0;          //"dignum name newsite"
int  maxsite=9, day=1, nf,ntotl, bofset,fofset=0,offset=0; //ntotl=total# ionogs
int  numsite[]= {0,1,2,3, 24,13,11,16, 0};      //= Ak,Ak,Ch,-, PM,Va,Mu,Ma,x
char *station[] = {"(UNKNOWN I.D. #)", "AUCKLAND,  N.Z. ",             //0, 1
	  "CHRISTCHURCH NZ.", " (Site 3 blank) ", "PORT MORESBY PNG",      //2,3,4
	  "VANIMO, Indones.", "MUNDARING  Aust.", "MACQUARIE Island",      //5,6,7
	  " (Site 8 blank) ", " (Site 9 blank) "  };                       //8, 9
char *dy[]= { "01","02","03","04","05","06","07","08","09","10",
			  "11","12","13","14","15","16","17","18","19","20",
			  "21","22","23","24","25","26","27","28","29","30","31" };
void main(int argc, char *argv[])
{   clrscr();
	printf("\n     DIGION system,  used with an IPS-42 ionosonde");
	printf("\n     Version 3.  Copyright 1993 by J.E. Titheridge");
	printf("\n     Physics Dept.,  University of Auckland,  N.Z.\n");
	printf("\n Program  DIGNUM  to change station numbers in data files.");
	printf("\n e.g.  \"DIGNUM  JUN93  6\"  will change all JUN93.dd files");
	printf("\n                                  to  Station Number =  6.");
	printf("\n       \"DIGNUM  JUN93  0  #\"  sets offset= #, for all files.");
	printf("\n       \"DIGNUM  JUN93\"  to list Files (with old SiteNumber).\n");
	if (argc >1) { strcpy(datfile, argv[1]);
	  if (argc>2)  newsite= atoi(argv[2]);
	  if (argc>3) { offset= atoi(argv[3]);                //list: df*100 + dh
            fofset= offset + 32-(offset/100)*36; }       //store: df*64 +dh+32
	  if (strlen(datfile) >2)  goto GET;    }
NEW: printf("\nEnter file name to process [MMMYY only]: ");
	 scanf("%s", datfile);  if (strlen(datfile) < 2)   exit(0);
	 printf("\nEnter new site number for these files: "); scanf("%d",&newsite);
GET: strcpy(getfile, datfile);   strcat(getfile, ".");
	 strcat(getfile, dy[day-1]);
	 if (access(getfile, 4) < 0)                               //==org chkdisks
		   { if (nodat==0) printf("\nNo Data on %s",getfile);
			 if (nodat==1) printf("; %s", getfile);
				 nodat= 1;   goto NXT;              }
		nodat = 0;
	 if ( (ptr= fopen(getfile, "r+b") ) == 0 )
		   { printf("\n#### Can't open file %s  ", getfile);  goto NXT; }
	 if ( fread(&fp,HSIZE,1,ptr) != 1)
		   { printf("\n#### Error in file info."); fclose(ptr); goto DUN; }
	 insite = fp.fsite; // if (insite>99) insite = 1;         //early undef= Akld
	 for (dsite= 1; dsite<=maxsite; dsite++)  //insite=statn#-> dsite sequence#
		   if (numsite[dsite]==insite) break;
		if (dsite>=maxsite) dsite= 0;                   //0 or >9 => 'unknown'
	 dyear = fp.fyear;  dname = station[dsite];  bofset = fp.fofset;
	 if ( (ntotl= fp.fnum) == 0 )  {  fclose( ptr );
			 printf( "\nFile %s is empty.", getfile );  exit(1); }
	 printf("\n%s  File= %s,  %d Ionograms.", dname,getfile,ntotl);
	 printf("  SiteNum= %u", insite);
     if (bofset!=0||argc>3)  { bofset = (bofset/64)*36 + bofset- 32;
                               printf("/Offset:%u", bofset); }
//                      CHANGE SITENUM (or OFFSET), and REWRITE HEADER
	 if (newsite>0) { printf("; Change to %u.",newsite); fp.fsite= newsite; }
     if (argc>3)    { printf("=>%u.", offset);   fp.fofset= fofset; }
 	 if (argc>3||newsite>0)  { rewind(ptr);  fwrite (&fp,HSIZE,1,ptr); }
NXT: fclose( ptr );
	 day = day + 1;
	 if (day <= 31)  goto GET;
DUN:  day = 1;   nodat = 0;
	  printf( "\n    Another Month to process ? [Y or N] " );
	  if ((c=getch())=='Y' || c=='y')  goto NEW;          //get a new file
	  else  exit(0);  }                                   //or end all
//end main

